
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

FILE *fp, *fz, *fk;
unsigned char *src;
unsigned char *key;
unsigned int nLen;
unsigned int kLen;

unsigned char xor1;
unsigned int  xor2;
unsigned int  xor3;
unsigned int tabj[0x100];
unsigned char tabs[6][0x100];
unsigned int tabi[0x20];
unsigned char tabii[0x100][5];
unsigned char tabs8[0x100][8];
unsigned char *tab_a, *tab_b;

#define _xor1_0(j, k) \
			m ^= tab_a[tab_b[m ^ key[(((i + m) ^ j) + xor1) & kLen]] ^ n] & (0x80 >> k); \
			n ^= tab_b[tab_a[n ^ key[(((i + n) ^ j) ^ xor3) & kLen]] ^ m] & (0x01 << k); \

#define _xor1(j) \
			_xor1_0((j) ^ (xor2 & 7), (j))

#define ixor(tab0, tab1) \
			xor1 ^= i >> (((tab0[i & n] >> 4) & 5) | (tab1[m] & 2)) \

#define rotate(j) \
			xor1 = (xor1 << j) | (xor1 >> (8 - j)) \

#define rev(n) (((n & 1) << 7) | ((n & 2) << 5) | ((n & 4) << 3) | ((n & 8) << 1) \
		| ((n >> 1) & 8) | ((n >> 3) & 4) | ((n >> 5) & 2) | ((n >> 7) & 1))

#define swr(n) ((n & 0x81) | ((n >> 3) & 2) | ((n & 2) << 1) | ((n >> 2) & 8) | ((n & 4) << 2) | ((n >> 1) & 0x20) | ((n & 8) << 3))

#define invert_bit(j) (1 << (j ^ ((xor1 ^ i) & 0x07)))

#define BS5(n, b4, b3, b2, b1, b0)		\
		(((((n) >> (b4)) & 1) <<  4) |	\
		 ((((n) >> (b3)) & 1) <<  3) |	\
		 ((((n) >> (b2)) & 1) <<  2) |	\
		 ((((n) >> (b1)) & 1) <<  1) |	\
		 ((((n) >> (b0)) & 1)))

#define BS8(n, b7, b6, b5, b4, b3, b2, b1, b0)	\
		(((((n) >> (b7)) & 1) << 7) |	\
		 ((((n) >> (b6)) & 1) << 6) |	\
		 ((((n) >> (b5)) & 1) << 5) |	\
		 ((((n) >> (b4)) & 1) << 4) |	\
		 ((((n) >> (b3)) & 1) << 3) |	\
		 ((((n) >> (b2)) & 1) << 2) |	\
		 ((((n) >> (b1)) & 1) << 1) |	\
		 ((((n) >> (b0)) & 1)))

void long_xor1(unsigned short ofst, unsigned char *dst)
{
	int x, y, i;

	y = tabs[5 ^ ((key[(ofst ^ ~xor3)      & kLen] >> ( xor3 & 7)) & 1)][(xor1     )       ] & 0x1f;
	x = tabs[4 ^ ((key[((ofst << 8) ^  ofst) & kLen] >> (~xor3 & 7)) & 1)][(xor2 >> y) & 0xff] & 0x3f;

	x |= 1; // odd gives better results

	for (i = 0, xor3 = x; i < y; i++, xor3*=x);

	dst[0] ^= tabs[4 | ((xor2 >> ((xor3 >>  0) & 0x1f)) & 1)][(xor3 >>  0) & 0xff];
	dst[1] ^= tabs[4 | ((xor1 >> ((xor3 >>  5) & 0x07)) & 1)][(xor3 >> 16) & 0xff];
	dst[2] ^= tabs[4 | ((y    >> ((xor3 >>  8) & 0x07)) & 1)][(xor3 >>  8) & 0xff];
	dst[3] ^= tabs[4 | ((xor3 >> ((xor3 >> 11) & 0x1f)) & 1)][(xor3 >> 24) & 0xff];

	x = y = i = 0;
}

unsigned char byte_xor2(unsigned short ofst, unsigned char i, unsigned int c)
{
	unsigned int axor;
	unsigned char *b8, r = xor2 & 1;
	char *f = tabii[ (xor2 >> (c & 0x18)) & 0xff ];
	int shift = xor1 >> ((ofst >> (rev(key[ofst & kLen]) & 0x1f)) & 7);

	xor2 = (xor2 << 1) | ((key[(xor2 + xor1) & kLen] >> shift) & 1);
	xor2 ^= c;
	xor2 ^= i << (4 | r);
	xor2 ^= rev(ofst >> 4) << 0x18;
	xor2 ^= ofst & 0x00f;
	xor2 ^= xor3 & 0xffffff00;

	axor = ~xor2;

	r = xor2 >> 0x18;

	if (xor2 & tabj[r]) xor2 ^= tabj[xor2 & r];

	if (xor2 & tabi[ 0]) r  = (r & 0xfe) | (xor2 & 0x01);
	if (axor & tabi[ 0]) r ^= xor1 & (1 << (r & 7));
	if (xor2 & tabi[ 1]) r  = (r << 0x01) | (r >> 0x07);
	if (axor & tabi[ 1]) r ^= 0x04;
	if (xor2 & tabi[ 2]) r ^= (xor2 >> 0x08) & 0x09;
	if (axor & tabi[ 2]) r  = (r >> 5) | (BS5(r, f[1], f[4], f[2], f[3], f[0]) << 3);
	if (axor & tabi[ 3]) r  = (r & 0xbf) | ((xor2 >> (i & 0x10)) & 0x40);
	if (axor & tabi[ 3]) r ^= 0xf7;
	if (xor2 & tabi[ 4]) r  = invert_bit(7);
	if (axor & tabi[ 4]) r ^= 0x10;
	if (xor2 & tabi[ 5]) r  = (r << 0x04) | (r >> 0x04);
	if (axor & tabi[ 5]) r ^= 0x7f;
	if (xor2 & tabi[ 6]) r ^= (xor2 >> 0x08) & 0x60;
	if (axor & tabi[ 6]) r ^= 0xdf;
	if (xor2 & tabi[ 7]) r  = (r & 0xfb) | (xor2 & 0x04);
	if (axor & tabi[ 7]) r  = r & 0xe0 | BS5(r, f[0], f[3], f[2], f[1], f[4]);
	if (xor2 & tabi[ 8]) r ^= invert_bit(4);
	if (axor & tabi[ 8]) r  = r & 0xe0 | BS5(r, f[4], f[3], f[2], f[1], f[0]);
	if (axor & tabi[ 9]) r  = rev(r);
	if (xor2 & tabi[ 9]) r ^= 0x80;
	if (xor2 & tabi[10]) r ^= invert_bit(2);
	if (axor & tabi[10]) r  = r & 0xe0 | BS5(r, f[3], f[1], f[4], f[2], f[0]);
	if (axor & tabi[11]) r ^= (xor2 >> 0x08) & 0x90;
	if (xor2 & tabi[11]) r ^= 0xbf;
	if (xor2 & tabi[12]) r  = (r & 0xf7) | (xor2 & 0x08);
	if (axor & tabi[12]) r ^= tabs[r % 6][r];
	if (xor2 & tabi[13]) r  = swr(r);
	if (axor & tabi[13]) r ^= 0x02;
	if (xor2 & tabi[14]) r ^= (xor2 >> 0x08) & 0x06;
	if (axor & tabi[14]) r ^= tabs[r % 6][((r^key[xor2 & kLen]) | (r << 8)) & 0xff];
	if (xor2 & tabi[15]) r ^= invert_bit(6);
	if (axor & tabi[15]) r ^= 0xff;
	if (xor2 & tabi[16]) r  = (r & 0xef) | ((xor2 >> (c & 0x10)) & 0x10);
	if (axor & tabi[16]) r  = r & 0xe0 | BS5(r, f[0], f[1], f[4], f[2], f[3]);
	if (xor2 & tabi[17]) r  = (r << 0x07) | (r >> 0x01);
	if (axor & tabi[17]) r ^= 0xa5;
	if (xor2 & tabi[18]) r ^= xor2 & 0xc0;
	if (axor & tabi[18]) r  = (~r & 0xf0) | (r & 0x0f);
	if (axor & tabi[19]) r ^= invert_bit(1);
	if (xor2 & tabi[19]) r ^= 0x20;
	if (axor & tabi[20]) r  = (r & 0xdf) | ((xor2 >> (c & 0x10)) & 0x20);
	if (axor & tabi[20]) r ^= 0x5a;
	if (xor2 & tabi[21]) r ^= invert_bit(3);
	if (axor & tabi[21]) r ^= tabs[r % 6][(((r^key[xor2 & kLen]) << 8) | r) & 0xff];
	if (xor2 & tabi[22]) r ^= xor2 & 0x03;
	if (axor & tabi[22]) r ^= 0x01;
	if (xor2 & tabi[23]) r ^= xor2 & 0x30;
	if (axor & tabi[23]) r  = (r & 0xf0) | (~r & 0x0f);
	if (axor & tabi[24]) r ^= invert_bit(0);
	if (axor & tabi[24]) r  = r & 0xe0 | BS5(r, f[1], f[2], f[3], f[0], f[4]);
	if (xor2 & tabi[25]) r  = (r & 0xfc) | ((r & 0x01) << 0x01) | ((r & 0x02) >> 0x01);
	if (axor & tabi[25]) r ^= 0xfe;
	if (xor2 & tabi[26]) r ^= invert_bit(5);
	if (axor & tabi[26]) r  = r & 0xc1 | (BS5(r>>1, f[3], f[2], f[4], f[1], f[0]) << 1);
	if (axor & tabi[27]) r ^= 0x40;
	if (axor & tabi[27]) r  = (r & 0xf9) | ((r & 0x02) << 0x01) | ((r & 0x04) >> 0x01);
	if (xor2 & tabi[28]) r  = (r & 0x7f) | ((xor2 >> (i & 0x10)) & 0x80);
	if (axor & tabi[28]) r  = r & 0x83 | (BS5(r >> 2, f[3], f[2], f[4], f[1], f[0]) << 2);
	if (xor2 & tabi[29]) r ^= ~rev(r);
	if (axor & tabi[29]) r  = r & 0x07 | (BS5(r >> 3, f[0], f[3], f[1], f[2], f[4]) << 3);
	if (xor2 & tabi[30]) r ^= xor2 & 0x0c;
	if (axor & tabi[30]) r ^= 0x08;
	if (xor2 & tabi[31]) r  = (r & 0xfd) | (xor2 & 0x02);
	if (axor & tabi[31]) r  = r & 0x83 | (BS5(r >> 2, f[2], f[1], f[0], f[4], f[3]) << 2);

	if (xor2 & tabj[r]) xor2 ^= tabj[xor2 & r];

	b8 = tabs8[tabs[r % 6][r] ^ r];

	xor2 ^= BS8(r, b8[7], b8[5], b8[4], b8[3], b8[1], b8[2], b8[0], b8[6]);

	return ~r;
}

void fill_tab(unsigned char *tab, unsigned short ofst)
{
	int i = 0, j, c = 0;

	memset (tab, xor2 & 0xff, 0x100);

	while (i < 0xff)
	{
		int d = byte_xor2(ofst, i, c);

		for (j = 0; j < 0x100 && tab[j] != d; j++);

		if (j == 0x100) {
			tab[i++] = d;
			d = 0;
		}

		c++;
	}

	i = j = c = 0;

	return;
}

void fill_tab_ii(unsigned char *tabii)
{
	int i = 3, j, c = 0;

	tabii[4] = ~xor3 % 5;

	while (i >= 0)
	{
		int d = byte_xor2(xor2 >> 16, ~xor1, xor3 ^ c) % 5;

		for (j = i+1; j < 5 && tabii[j] != d; j++);

		if (j == 5) {
			tabii[i--] = d;
		}

		c++;
	}

	i = j = c = 0;

	return;
}

void fill_tab_bs8(unsigned char *tabs)
{
	int i = 1, j, c = 0;

	memset (tabs, -1, 8);

	tabs[0] = ~xor3 % 8;

	while (i < 8)
	{
		int d = (byte_xor2(xor2 >> 16, ~xor1, xor3 + c + j) ^ c) & 7;

		for (j = 0; j < 8 && tabs[j] != d; j++);

		if (j == 8) {
			tabs[i++] = d;
		}

		c++;
	}

	xor3 += c << 1;

	i = j = c = 0;

	return;
}

void fill_tabs(unsigned short ofst)
{
	int ktmp = key[ofst & kLen];

	int i, k, v;
	k = (xor2 ^ xor3) & xor1;
	for (i = 0; i < 0x100; i++) {
		fill_tab_ii(tabii[i ^ k]);
		fill_tab_bs8(tabs8[i ^ ktmp]);
	}

	int shift = (xor1 & 7);

	char *r = tabii[rev(~key[~xor2 & kLen])];
	char *f = tabii[     key[ xor2 & kLen] ];
	k = tabs[key[(( xor1 << 8) | xor1) & kLen] % 6][xor2 >> 24];
	v = tabs[key[((~xor1 << 8) | xor1) & kLen] % 6][(xor2 >> 16) & 0xff];
	for (i = 0; i < 32; i++) {
		tabi[BS5(i ^ k, f[r[4]], f[r[2]], f[r[1]], f[r[3]], f[r[0]])] = 1 << BS5(i ^ v, r[f[4]], r[f[0]], r[f[2]], r[f[3]], r[f[1]]);
	}

	fill_tab(tabs[0 ^ ((ktmp >> (xor1 & 7)) & 3)], ofst);
	fill_tab(tabs[1 ^ ((ktmp >> (xor1 & 7)) & 3)], ofst);
	fill_tab(tabs[2 ^ ((ktmp >> (xor1 & 7)) & 3)], ofst);
	fill_tab(tabs[3 ^ ((ktmp >> (xor1 & 7)) & 3)], ofst);

	fill_tab(tabs[4], ~ofst ^ (ktmp << 4));
	fill_tab(tabs[5], ~ofst ^ (ktmp << 8));

	for (i = 0; i < 0x100; i++) {
		tabj[i]  = 0x00000001 << (tabs[i & 3][key[(xor3 ^ xor1) & kLen] ^ i] & 0x0f);
		tabj[i] ^= 0x00010000 << (tabs[i & 3][key[xor2 & kLen]          ^ i] >>   4);
	}

	ktmp = 0;
	r = f = NULL;
	i = k = 0;

	return;
}

unsigned char byte_xor1(unsigned int i)
{
	unsigned char m, n;

	m = i >> 0x18;
	n = i >> 0x10;

	_xor1(0);
	_xor1(1);
	_xor1(2);
	_xor1(3);
	_xor1(4);
	_xor1(5);
	_xor1(6);
	_xor1(7);

	tab_a = tabs[((i ^ n) & 2)    ];
	tab_b = tabs[((i ^ m) & 2) | 1];

	rotate(m & 7);

	ixor(tab_a, tab_b);
	ixor(tab_b, tab_a);

	rotate(n & 7);

	xor1 ^= tab_a[xor1 ^ key[xor2 & kLen]];
	xor1 ^= tab_b[i & (m ^ n)];

	m = n = 0;

	return xor1;
}

unsigned char byte_xor3(unsigned int i)
{
	unsigned int j, k, r;
	unsigned char *b8;

	for (k = 0, j = i; k < 32; k++, xor2+=2, xor1++) {
		j ^= (i >> k);
		if (k &  4) j ^= ((i * j) & 0x0f) << k;
		if (k &  2) j ^= ((i / (j | 1)) << 2);
		if (k &  8) j ^= (j << 2);
		if (k &  1) j ^= 1 << (j << (((j+i) >> (j & 31)) & 31));
		if (k & 16) j  = (j << ((xor2 >> (xor1 & 0x1f)) & 0x1f)) | (j >> (31-((xor2 >> (xor1 & 0x1f)) & 0x1f)));
	}

	if (key[(i ^ (i >> 16)) & kLen] & (1 << (j & 7)))
	{
		int a, b, c, d, e, f;

		b = key[j & kLen];
		c = (b << 3) & 0x18;
		d = (b << 1) & 0x18;
		e = (b >> 1) & 0x18;
		f = (b >> 3) & 0x18;
		a = (j >> (c | d)) & 7;

		b8 = tabs8[tabs[(j >> c) % 6][(j >> d) & 0xff] ^ ((j >> e) & 0xff)];

		r = BS8(j >> f, b8[2^a], b8[4^a], b8[3^a], b8[5^a], b8[7^a], b8[0^a], b8[6^a], b8[1^a]);

		b = c = d = e = f = 0;
	} else {
		for (k = r = 0; k < 8; k++) {
			r |= ((j >> (k ^ ((j >> 3) & 31))) & 1) << k;
		}
	}

	j = k = 0;

	return r;
}

void crypt(unsigned char *src, unsigned int nLen)
{
	unsigned int i = 0, j = 0, tdr = 0, dstaddr;
	unsigned int block = 0;
	unsigned char xor_byte = 0;
	unsigned char *b8;

	// seed
	for (i = j = xor3 = 0; i < kLen; i++, xor3 += key[i]) {
		j ^= key[i];
		xor2 += j;
		j += swr(key[j & kLen]);
		j += byte_xor3(j + i);
		xor1 = j;
		tdr = (xor2 >> (xor1 & 0x1f)) & 0x18;
		j = (rev(j>>24)<<(24^tdr)) | (swr(j>>16)<<(16^tdr)) | (rev(j>>8)<<(8^tdr)) | (rev(j)<<tdr);
		j = (~j << 31) | (j >> 1);

		xor3 ^= xor2 & j;
		xor3 = (xor3 << ((xor1 >> 3) & 0x1f)) | (xor3 >> (31-((xor1 >> 3) & 0x1f)));
	}

	if (!j) j = ~0;
	if (!xor3) xor3 = ~0x543210c8;
	if (!xor2) xor2 = ~0x1234597a;

	tab_a = tabs[(j >> 4) & 2];
	tab_b = tabs[(j & 2)  | 1];

	for (i = 0, j = xor2, tdr = 0, xor2 = 0; i < 32; i++) {
		xor2 |= ((j >> i) & 1) << (i ^ (j & 0x1f));
		tdr  |= ((j >> (i ^ (j & 0x1f))) & 1) << i;
	}

	for (i = 0; i < nLen; i+= 0x10000)
	{
		fill_tabs(i >> 16);

		block = (nLen - i) < 0x10000 ? (nLen - i) : 0x10000;

		fread (src, 1, block, fp);

		for (j = 0; j < block; j++)
		{
			xor_byte  = byte_xor1(i + j + tdr);
			xor_byte ^= byte_xor2(i >> 16, xor1, j << (tdr >> (j >> 13)));
			xor_byte ^= byte_xor3(i + j + tdr);

			b8 = tabs8[xor_byte];

			xor_byte = BS8(xor_byte, b8[0], b8[1], b8[2], b8[3], b8[4], b8[5], b8[6], b8[7]);

			long_xor1(j, src + j);

			src[j] ^= xor_byte;
		}

		j ^= (xor1 + (xor2 ^ xor3)) ^ xor_byte;

		b8 = tabs8[(j >>  0) & 0xff];
		tdr = (j & 0x00ffffff) | (BS8(j >> 16, b8[0], b8[7], b8[2], b8[4], b8[5], b8[3], b8[6], b8[1]) << 24);
		b8 = tabs8[(j >> 16) & 0xff];
		tdr = (j & 0xffff00ff) | (BS8(j >>  8, b8[2], b8[6], b8[0], b8[3], b8[4], b8[1], b8[5], b8[7]) << 16);
		b8 = tabs8[(j >> 24) & 0xff];
		tdr = (j & 0xff00ffff) | (BS8(j >> 24, b8[4], b8[2], b8[6], b8[7], b8[0], b8[5], b8[1], b8[3]) <<  8);
		b8 = tabs8[(j >>  8) & 0xff];
		tdr = (j & 0xffffff00) | (BS8(j >>  0, b8[7], b8[1], b8[5], b8[6], b8[3], b8[2], b8[4], b8[0]) <<  0);

		src[0] ^= src[0x10000]; // wrap long xor around
		src[1] ^= src[0x10001];
		src[2] ^= src[0x10002];

		fwrite (src, 1, block, fz);
		printf (".");
	}

	i = j = block = tdr = 0;
}

int main(int argc, char **argv)
{
	int kfile = 0;
	char filein[256], fileout[256];
	char tkey[256];
	unsigned char *tmpkey;

	if (argc < 2)
	{
		printf ("Please type the name of the file to be en/de-crypted\n");
		fgets(filein, 256, stdin);
		if (filein[strlen(filein)-1] == '\n') filein[strlen(filein)-1] = '\0';
		strcpy (fileout, filein);
	}
	else
	{
		strcpy (fileout, argv[1]);
	}

	fp = fopen(fileout, "rb");

	if (fp == NULL)
	{
		printf ("File not found\n");
		fgets (filein, 1, stdin);
		return 1;
	}

	fseek (fp, 0, SEEK_END);
	nLen = ftell (fp);
	rewind (fp);

	if (argc < 3)
	{
		printf ("\nPlease type the name of the key file or the password you wish to use.\n");
		fgets(tkey, 256, stdin);
		if (tkey[strlen(tkey)-1] == '\n') tkey[strlen(tkey)-1] = '\0';
	}
	else
	{
		strcpy (tkey, argv[2]);
	}

	fk = fopen(tkey, "rb");
	if (fk != NULL)
	{
		printf ("\nUsing key file...\n");
		fseek (fk, 0, SEEK_END);
		kLen = ftell (fk);
		rewind (fk);
		if (kLen < 8) {
			printf ("\nKey file must be at least 8 bytes.\n");
			fclose (fk);
			return 1;
		}

		if (kLen > 0x10000) {
			printf ("\nOnly using first 64kb of key...\n");
			kLen = 0x10000;
		}

		key = (unsigned char *)malloc ( kLen );

		fread (key, 1, kLen, fk);
		fclose (fk);

		kfile = 1;
	}
	else
	{
		key = tkey;
		kLen = strlen( tkey );
		if (kLen < 8) {
			printf ("Password must be longer than 8 characters.\n");
			return 1;
		}
	}

	{
		unsigned int x, y;
		for (x = 0; x < 32; x++) {
			if (kLen == (1 << x)) {
				kLen -= 1;
				break;
			}

			if (kLen < (1 << x)) {
				tmpkey = (unsigned char*)malloc(1 << x);
				memset (tmpkey, 0, 1 << x);
				for (y = 0; y < 1 << x; y++) {
					tmpkey[y] = key[y & kLen];
				}
				memset (key, 0, kLen);
				kLen = (1 << x) - 1;
				free (key);	
				key = NULL;
				key = tmpkey;

				break;
			}
		}
	}

	if (strncmp (fileout + (strlen(fileout) - 4), ".enc", 4) == 0) {
		fileout[strlen(fileout) - 4] = '\0';
	} else {
		strcat (fileout, ".enc");
	}

	fz = fopen(fileout, "wb");

	src = (unsigned char*)malloc( 0x10004 );
	if (src == NULL) {
		return 1;
	}

	memset (src, 0, 0x10004);

	time_t xx = time(NULL);

	crypt(src, nLen);

	printf ("\n\nFinished in %d bytes in %d seconds\n", nLen, time(NULL)-xx);

	fclose (fp);
	fclose (fz);

	{
		if (kfile) {
			free (key);
			key = NULL;
		}
			memset (tkey, 0, 0x100);
		kfile = 0;
		kLen = xor1 = xor2 = xor3 = 0;
		memset (tabs,	0, 0x600);
		memset (tabs8,  0, 0x800);
		memset (key,	0, kLen);
		memset (tabi,	0, 0x80);
		memset (tabii,	0, 0x500);
		memset (tabj,	0, 0x400);
		memset (src,	0, 0x10004);
		tab_a = tab_b = NULL;
		free (src);
		src = NULL;
		tmpkey = NULL;
	}
}
